From 3b4a5edcaeaa3f7ef48485e6571ee0e14b642160 Mon Sep 17 00:00:00 2001
From: Stephanie Buser <sbuser@codeaurora.org>
Date: Tue, 6 Jun 2017 09:39:56 -0700
Subject: [PATCH 16/22] QMI WWAN Patch to fix RTNL warnings

---
 drivers/net/usb/qmi_wwan.c | 8 ++++++++
 1 file changed, 8 insertions(+)

diff --git a/drivers/net/usb/qmi_wwan.c b/drivers/net/usb/qmi_wwan.c
index 374276d..954495d 100644
--- a/drivers/net/usb/qmi_wwan.c
+++ b/drivers/net/usb/qmi_wwan.c
@@ -20,6 +20,7 @@
 #include <linux/usb/cdc.h>
 #include <linux/usb/usbnet.h>
 #include <linux/usb/cdc-wdm.h>
+#include <linux/rtnetlink.h>
 
 /* This driver supports wwan (3G/LTE/?) devices using a vendor
  * specific management protocol called Qualcomm MSM Interface (QMI) -
@@ -101,9 +102,13 @@ static ssize_t raw_ip_store(struct device *d,  struct device_attribute *attr, co
 	if (enable == (info->flags & QMI_WWAN_FLAG_RAWIP))
 		return len;
 
+	if (!rtnl_trylock())
+		return restart_syscall();
+
 	/* we don't want to modify a running netdev */
 	if (netif_running(dev->net)) {
 		netdev_err(dev->net, "Cannot change a running device\n");
+		rtnl_unlock();
 		return -EBUSY;
 	}
 
@@ -112,6 +117,7 @@ static ssize_t raw_ip_store(struct device *d,  struct device_attribute *attr, co
 	err = notifier_to_errno(err);
 	if (err) {
 		netdev_err(dev->net, "Type change was refused\n");
+		rtnl_unlock();
 		return err;
 	}
 
@@ -121,6 +127,8 @@ static ssize_t raw_ip_store(struct device *d,  struct device_attribute *attr, co
 		info->flags &= ~QMI_WWAN_FLAG_RAWIP;
 	qmi_wwan_netdev_setup(dev->net);
 	call_netdevice_notifiers(NETDEV_POST_TYPE_CHANGE, dev->net);
+
+	rtnl_unlock();
 	return len;
 }
 
-- 
1.8.2.1

